Index: /nanovis/branches/1.1/nanovis.cpp
===================================================================
--- /nanovis/branches/1.1/nanovis.cpp	(revision 4611)
+++ /nanovis/branches/1.1/nanovis.cpp	(revision 4612)
@@ -59,10 +59,10 @@
 #include "define.h"
 
-#include "FlowCmd.h"
+#include "Command.h"
+#include "Flow.h"
 #include "Grid.h"
 #include "HeightMap.h"
 #include "NvCamera.h"
 #include "NvShader.h"
-#include "NvFlowVisRenderer.h"
 #include "NvLIC.h"
 #include "NvZincBlendeReconstructor.h"
@@ -82,4 +82,5 @@
 using namespace nv::graphics;
 using namespace nv::util;
+using namespace vrmath;
 
 #define SIZEOF_BMP_HEADER   54
@@ -141,10 +142,7 @@
 float NanoVis::wMin = FLT_MAX;
 float NanoVis::wMax = -FLT_MAX;
-vrmath::Vector3f NanoVis::sceneMin, NanoVis::sceneMax;
+Vector3f NanoVis::sceneMin, NanoVis::sceneMax;
 
 VolumeRenderer *NanoVis::volRenderer = NULL;
-#ifdef notdef
-NvFlowVisRenderer *NanoVis::flowVisRenderer = NULL;
-#endif
 VelocityArrowsSlice *NanoVis::velocityArrowsSlice = NULL;
 NvLIC *NanoVis::licRenderer = NULL;
@@ -167,7 +165,4 @@
 GLuint NanoVis::_finalDepthRb = 0;
 
-// in Command.cpp
-extern Tcl_Interp *initTcl();
-
 // Default camera location.
 float def_eye_x = 0.0f;
@@ -199,10 +194,4 @@
         delete legendTexture;
     }
-#ifdef notdef
-    if (flowVisRenderer != NULL) {
-        TRACE("Deleting flowVisRenderer");
-        delete flowVisRenderer;
-    }
-#endif
     TRACE("Deleting flows");
     deleteFlows(interp);
@@ -570,13 +559,21 @@
 /** \brief Load a 3D volume
  *
- * \param n_component the number of scalars for each space point. All component 
+ * \param name Volume ID
+ * \param width Number of samples in X direction
+ * \param height Number of samples in Y direction
+ * \param depth Number of samples in Z direction
+ * \param numComponents the number of scalars for each space point. All component 
  * scalars for a point are placed consequtively in data array
  * width, height and depth: number of points in each dimension
+ * \param data Array of floats
+ * \param vmin Min value of field
+ * \param vmax Max value of field
+ * \param nonZeroMin Minimum non-zero value of field
  * \param data pointer to an array of floats.
  */
 Volume *
 NanoVis::loadVolume(const char *name, int width, int height, int depth, 
-                    int n_component, float *data, double vmin, double vmax, 
-                    double nzero_min)
+                    int numComponents, float *data, double vmin, double vmax, 
+                    double nonZeroMin)
 {
     VolumeHashmap::iterator itr = volumeTable.find(name);
@@ -588,6 +585,6 @@
     Volume *volume = new Volume(0.f, 0.f, 0.f,
                                 width, height, depth,
-                                n_component,
-                                data, vmin, vmax, nzero_min);
+                                numComponents,
+                                data, vmin, vmax, nonZeroMin);
     Volume::updatePending = true;
     volume->name(name);
@@ -884,9 +881,5 @@
     fonts->setFont("verdana");
 
-#ifdef notdef
-    flowVisRenderer = new NvFlowVisRenderer(NMESH, NMESH);
-#endif
     velocityArrowsSlice = new VelocityArrowsSlice;
-
     licRenderer = new NvLIC(NMESH, NPIX, NPIX, _licAxis, _licSlice);
 
@@ -936,5 +929,5 @@
     initOffscreenBuffer();    //frame buffer object for offscreen rendering
 
-    //create volume renderer and add volumes to it
+    //create volume renderer
     volRenderer = new VolumeRenderer();
 
@@ -949,42 +942,4 @@
     TRACE("leaving initGL");
 }
-
-#ifdef DO_RLE
-char rle[512*512*3];
-int rleSize;
-
-short offsets[512*512*3];
-int offsetsSize;
-
-static void 
-doRle()
-{
-    int len = NanoVis::winWidth*NanoVis::winHeight*3;
-    rleSize = 0;
-    offsetsSize = 0;
-
-    int i = 0;
-    while (i < len) {
-        if (NanoVis::screenBuffer[i] == 0) {
-            int pos = i+1;
-            while ( (pos < len) && (NanoVis::screenBuffer[pos] == 0)) {
-                pos++;
-            }
-            offsets[offsetsSize++] = -(pos - i);
-            i = pos;
-        }
-
-        else {
-            int pos;
-            for (pos = i; (pos < len) && (NanoVis::screenBuffer[pos] != 0); pos++){
-                rle[rleSize++] = NanoVis::screenBuffer[pos];
-            }
-            offsets[offsetsSize++] = (pos - i);
-            i = pos;
-        }
-
-    }
-}
-#endif
 
 // used internally to build up the BMP file header
@@ -1525,5 +1480,5 @@
             continue;
 
-        vrmath::Vector3f bmin, bmax;
+        Vector3f bmin, bmax;
         volume->getWorldSpaceBounds(bmin, bmax);
         if (bmin.x > bmax.x)
@@ -1557,5 +1512,5 @@
             continue;
 
-        vrmath::Vector3f bmin, bmax;
+        Vector3f bmin, bmax;
         heightMap->getWorldSpaceBounds(bmin, bmax);
         if (bmin.x > bmax.x)
@@ -1582,5 +1537,5 @@
     }
 
-    vrmath::Vector3f flowMin, flowMax;
+    Vector3f flowMin, flowMax;
     getFlowBounds(flowMin, flowMax, onlyVisible);
     if (flowMin.x < flowMax.x) {
@@ -1622,4 +1577,189 @@
     TRACE("Setting bgcolor to %g %g %g", color[0], color[1], color[2]);
     glClearColor(color[0], color[1], color[2], 1);
+}
+
+Flow *
+NanoVis::getFlow(const char *name)
+{
+    FlowHashmap::iterator itr = flowTable.find(name);
+    if (itr == flowTable.end()) {
+        TRACE("Can't find flow '%s'", name);
+        return NULL;
+    }
+    return itr->second;
+}
+
+Flow *
+NanoVis::createFlow(Tcl_Interp *interp, const char *name)
+{
+    FlowHashmap::iterator itr = flowTable.find(name);
+    if (itr != flowTable.end()) {
+        ERROR("Flow '%s' already exists", name);
+        return NULL;
+    }
+    Flow *flow = new Flow(interp, name);
+    flowTable[name] = flow;
+    return flow;
+}
+
+/**
+ * \brief Delete flow object and hash table entry
+ *
+ * This is called by the flow command instance delete callback
+ */
+void
+NanoVis::deleteFlow(const char *name)
+{
+    FlowHashmap::iterator itr = flowTable.find(name);
+    if (itr != flowTable.end()) {
+        delete itr->second;
+        flowTable.erase(itr);
+    }
+}
+
+/**
+ * \brief Delete all flow object commands
+ *
+ * This will also delete the flow objects and hash table entries
+ */
+void
+NanoVis::deleteFlows(Tcl_Interp *interp)
+{
+    FlowHashmap::iterator itr;
+    for (itr = flowTable.begin();
+         itr != flowTable.end(); ++itr) {
+        Tcl_DeleteCommandFromToken(interp, itr->second->getCommandToken());
+    }
+    flowTable.clear();
+}
+
+bool
+NanoVis::mapFlows()
+{
+    TRACE("Enter");
+
+    flags &= ~MAP_FLOWS;
+
+    /* 
+     * Step 1. Get the overall min and max magnitudes of all the 
+     *         flow vectors.
+     */
+    magMin = DBL_MAX, magMax = -DBL_MAX;
+
+    for (FlowHashmap::iterator itr = flowTable.begin();
+         itr != flowTable.end(); ++itr) {
+        Flow *flow = itr->second;
+        double min, max;
+        if (!flow->isDataLoaded()) {
+            continue;
+        }
+        Rappture::Unirect3d *data = flow->data();
+        min = data->magMin();
+        max = data->magMax();
+        if (min < magMin) {
+            magMin = min;
+        } 
+        if (max > magMax) {
+            magMax = max;
+        }
+        if (data->xMin() < xMin) {
+            xMin = data->xMin();
+        }
+        if (data->yMin() < yMin) {
+            yMin = data->yMin();
+        }
+        if (data->zMin() < zMin) {
+            zMin = data->zMin();
+        }
+        if (data->xMax() > xMax) {
+            xMax = data->xMax();
+        }
+        if (data->yMax() > yMax) {
+            yMax = data->yMax();
+        }
+        if (data->zMax() > zMax) {
+            zMax = data->zMax();
+        }
+    }
+
+    TRACE("magMin=%g magMax=%g", NanoVis::magMin, NanoVis::magMax);
+
+    /* 
+     * Step 2. Generate the vector field from each data set. 
+     */
+    for (FlowHashmap::iterator itr = flowTable.begin();
+         itr != flowTable.end(); ++itr) {
+        Flow *flow = itr->second;
+        if (!flow->isDataLoaded()) {
+            continue; // Flow exists, but no data has been loaded yet.
+        }
+        if (flow->visible()) {
+            flow->initializeParticles();
+        }
+        if (!flow->scaleVectorField()) {
+            return false;
+        }
+        // FIXME: This doesn't work when there is more than one flow.
+        licRenderer->setOffset(flow->getRelativePosition());
+        velocityArrowsSlice->slicePos(flow->getRelativePosition());
+    }
+    advectFlows();
+    return true;
+}
+
+void
+NanoVis::getFlowBounds(Vector3f& min,
+                       Vector3f& max,
+                       bool onlyVisible)
+{
+    TRACE("Enter");
+
+    min.set(FLT_MAX, FLT_MAX, FLT_MAX);
+    max.set(-FLT_MAX, -FLT_MAX, -FLT_MAX);
+
+    for (FlowHashmap::iterator itr = flowTable.begin();
+         itr != flowTable.end(); ++itr) {
+        itr->second->getBounds(min, max, onlyVisible);
+    }
+}
+
+void
+NanoVis::renderFlows()
+{
+    for (FlowHashmap::iterator itr = flowTable.begin();
+         itr != flowTable.end(); ++itr) {
+        Flow *flow = itr->second;
+        if (flow->isDataLoaded() && flow->visible()) {
+            flow->render();
+        }
+    }
+    flags &= ~REDRAW_PENDING;
+}
+
+void
+NanoVis::resetFlows()
+{
+    if (licRenderer->active()) {
+        NanoVis::licRenderer->reset();
+    }
+    for (FlowHashmap::iterator itr = flowTable.begin();
+         itr != flowTable.end(); ++itr) {
+        Flow *flow = itr->second;
+        if (flow->isDataLoaded() && flow->visible()) {
+            flow->resetParticles();
+        }
+    }
+}    
+
+void
+NanoVis::advectFlows()
+{
+    for (FlowHashmap::iterator itr = flowTable.begin();
+         itr != flowTable.end(); ++itr) {
+        Flow *flow = itr->second;
+        if (flow->isDataLoaded() && flow->visible()) {
+            flow->advect();
+        }
+    }
 }
 
@@ -1652,7 +1792,7 @@
     bindOffscreenBuffer();
 
-    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //clear screen
-
-    //3D rendering mode
+    //clear screen
+    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+
     glEnable(GL_DEPTH_TEST);
     glEnable(GL_COLOR_MATERIAL);
@@ -1701,9 +1841,4 @@
         velocityArrowsSlice->render();
     }
-#ifdef notdef
-    if ((flowVisRenderer != NULL) && (flowVisRenderer->active())) {
-        flowVisRenderer->render();
-    }
-#endif
     if (!flowTable.empty()) {
         renderFlows();
@@ -1826,14 +1961,7 @@
         exitService(90);
     }
-#ifdef DO_RLE
-    doRle();
-    int sizes[2] = {  offsets_size*sizeof(offsets[0]), rle_size };
-    TRACE("Writing %d,%d", sizes[0], sizes[1]); 
-    write(1, &sizes, sizeof(sizes));
-    write(1, offsets, offsets_size*sizeof(offsets[0]));
-    write(1, rle, rle_size);    //unsigned byte
-#else
+
     ppmWrite("nv>image -type image -bytes");
-#endif
+
     TRACE("Leave");
 }
Index: /nanovis/branches/1.1/nanovis.h
===================================================================
--- /nanovis/branches/1.1/nanovis.h	(revision 4611)
+++ /nanovis/branches/1.1/nanovis.h	(revision 4612)
@@ -51,5 +51,4 @@
 class PointSetRenderer;
 class NvParticleRenderer;
-class NvFlowVisRenderer;
 class PlaneRenderer;
 class VelocityArrowsSlice;
@@ -58,10 +57,9 @@
 class Texture2D;
 class HeightMap;
-class NvVectorField;
 class Grid;
 class NvCamera;
 class TransferFunction;
 class Volume;
-class FlowCmd;
+class Flow;
 
 class NanoVis
@@ -88,5 +86,5 @@
     typedef std::tr1::unordered_map<TransferFunctionId, TransferFunction *> TransferFunctionHashmap;
     typedef std::tr1::unordered_map<VolumeId, Volume *> VolumeHashmap;
-    typedef std::tr1::unordered_map<FlowId, FlowCmd *> FlowHashmap;
+    typedef std::tr1::unordered_map<FlowId, Flow *> FlowHashmap;
     typedef std::tr1::unordered_map<HeightMapId, HeightMap *> HeightMapHashmap;
 
@@ -134,8 +132,8 @@
 
     static Volume *loadVolume(const char *tag, int width, int height, int depth,
-                              int n, float* data, double vmin, double vmax, 
+                              int numComponents, float *data, double vmin, double vmax, 
                               double nonZeroMin);
 
-    static void removeVolume(Volume *volPtr);
+    static void removeVolume(Volume *volume);
 
     static void readScreen()
@@ -149,6 +147,6 @@
     }
 
-    static FlowCmd *getFlow(const char *name);
-    static FlowCmd *createFlow(Tcl_Interp *interp, const char *name);
+    static Flow *getFlow(const char *name);
+    static Flow *createFlow(Tcl_Interp *interp, const char *name);
     static void deleteFlow(const char *name);
     static void deleteFlows(Tcl_Interp *interp);
@@ -190,7 +188,4 @@
 
     static VolumeRenderer *volRenderer;
-#ifdef notdef
-    static NvFlowVisRenderer *flowVisRenderer;
-#endif
     static VelocityArrowsSlice *velocityArrowsSlice;
     static NvLIC *licRenderer;
